import meerkat.bulletinboard.BulletinBoardClient;
import meerkat.protobuf.BulletinBoardAPI;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Vladimir Eliezer Tokarev  on 2/19/2016.
 * Class that gives the ability of retrieve data from BulletinBoardClient synchronously
 */
public class DummyBulletinBoardCallBackHandler implements
        BulletinBoardClient.ClientCallback<List<BulletinBoardAPI.BulletinBoardMessage>> {
    private List<BulletinBoardAPI.BulletinBoardMessage> messages;

    public DummyBulletinBoardCallBackHandler()
    {
        messages = new ArrayList<>();
    }

    /**
     * Sets the received messages to be messages
     * @param msg List<BulletinBoardAPI.BulletinBoardMessage>  passed by BulletinBoardClient
     */
    @Override
    public void handleCallback(List<BulletinBoardAPI.BulletinBoardMessage> msg) {
        messages = msg;
    }

    /**
     * Sets the messages to be null because during the BulletinBoardAction was an error
     * @param t the information of the excretion thrown during the process
     */
    @Override
    public void handleFailure(Throwable t) {
        messages = null;
    }

    /**
     * Method that waits that the messages will arrive from bulletin board client
     * @return  List<BulletinBoardAPI.BulletinBoardMessage>
     */
    public List<BulletinBoardAPI.BulletinBoardMessage> getMessages(){
        while(messages.isEmpty()){
            if (messages == null)
            {
                return null;
            }
        }
        return messages;
    }
}
