import meerkat.VoterRegistry;

/**
 * Created by Vladimir Eliezer Tokarev  on 2/19/2016.
 * Object that gives the ability of synchronously access to SimpleVoterRegistry returned values
 */
public class DummyRegistryCallBackHandler<T> implements VoterRegistry.RegistryCallBack<T>{
    /**
     * The amount of times HandleResult had been called
     */
    public int counter;

    /**
     * The data the VoterRegistry have returned
     */
    public T data;

    public DummyRegistryCallBackHandler()
    {
        counter=0;
    }

    /**
     * Sets the retrieved data into data field and increases the counter
     * @param result    the answer VoterRegistry passed
     */
    @Override
    public void HandleResult(T result) {
        counter++;
        data = result;
    }
}
